<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/tasks/v2beta2/target.proto

namespace Google\Cloud\Tasks\V2beta2;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * App Engine Routing.
 * For more information about services, versions, and instances see
 * [An Overview of App Engine](/appengine/docs/python/an-overview-of-app-engine),
 * [Microservices Architecture on Google App Engine](/appengine/docs/python/microservices-on-app-engine),
 * [App Engine Standard request routing](/appengine/docs/standard/python/how-requests-are-routed),
 * and [App Engine Flex request routing](/appengine/docs/flexible/python/how-requests-are-routed).
 *
 * Generated from protobuf message <code>google.cloud.tasks.v2beta2.AppEngineRouting</code>
 */
class AppEngineRouting extends \Google\Protobuf\Internal\Message
{
    /**
     * App service.
     * By default, the task is sent to the service which is the default
     * service when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string service = 1;</code>
     */
    private $service = '';
    /**
     * App version.
     * By default, the task is sent to the version which is the default
     * version when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     */
    private $version = '';
    /**
     * App instance.
     * By default, the task is sent to an instance which is available when
     * the task is attempted.
     * Requests can only be sent to a specific instance if
     * [manual scaling is used in App Engine Standard](/appengine/docs/python/an-overview-of-app-engine?hl=en_US#scaling_types_and_instance_classes).
     * App Engine Flex does not support instances. For more information, see
     * [App Engine Standard request routing](/appengine/docs/standard/python/how-requests-are-routed)
     * and [App Engine Flex request routing](/appengine/docs/flexible/python/how-requests-are-routed).
     *
     * Generated from protobuf field <code>string instance = 3;</code>
     */
    private $instance = '';
    /**
     * Output only. The host that the task is sent to.
     * For more information, see
     * [How Requests are Routed](/appengine/docs/standard/python/how-requests-are-routed).
     * The host is constructed as:
     * * `host = [application_domain_name]`</br>
     *   `| [service] + '.' + [application_domain_name]`</br>
     *   `| [version] + '.' + [application_domain_name]`</br>
     *   `| [version_dot_service]+ '.' + [application_domain_name]`</br>
     *   `| [instance] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_service] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version_dot_service] + '.' + [application_domain_name]`
     * * `application_domain_name` = The domain name of the app, for
     *   example <app-id>.appspot.com, which is associated with the
     *   queue's project ID. Some tasks which were created using the App Engine
     *   SDK use a custom domain name.
     * * `service =` [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `version =` [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `version_dot_service =`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance =` [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]
     * * `instance_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance_dot_version =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `instance_dot_version_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service] is empty, then the task will be sent
     * to the service which is the default service when the task is attempted.
     * If [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] is empty, then the task will be sent
     * to the version which is the default version when the task is attempted.
     * If [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is empty, then the task
     * will be sent to an instance which is available when the task is
     * attempted.
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], or
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is invalid, then the task
     * will be sent to the default version of the default service when
     * the task is attempted.
     *
     * Generated from protobuf field <code>string host = 4;</code>
     */
    private $host = '';

    public function __construct() {
        \GPBMetadata\Google\Cloud\Tasks\V2Beta2\Target::initOnce();
        parent::__construct();
    }

    /**
     * App service.
     * By default, the task is sent to the service which is the default
     * service when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string service = 1;</code>
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }

    /**
     * App service.
     * By default, the task is sent to the service which is the default
     * service when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string service = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setService($var)
    {
        GPBUtil::checkString($var, True);
        $this->service = $var;

        return $this;
    }

    /**
     * App version.
     * By default, the task is sent to the version which is the default
     * version when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * App version.
     * By default, the task is sent to the version which is the default
     * version when the task is attempted.
     * For some queues or tasks which were created using the App Engine
     * Task Queue API, [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable
     * into [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]. For example, some tasks
     * which were created using the App Engine SDK use a custom domain
     * name; custom domains are not parsed by Cloud Tasks. If
     * [host][google.cloud.tasks.v2beta2.AppEngineRouting.host] is not parsable, then
     * [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], and
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] are the empty string.
     *
     * Generated from protobuf field <code>string version = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setVersion($var)
    {
        GPBUtil::checkString($var, True);
        $this->version = $var;

        return $this;
    }

    /**
     * App instance.
     * By default, the task is sent to an instance which is available when
     * the task is attempted.
     * Requests can only be sent to a specific instance if
     * [manual scaling is used in App Engine Standard](/appengine/docs/python/an-overview-of-app-engine?hl=en_US#scaling_types_and_instance_classes).
     * App Engine Flex does not support instances. For more information, see
     * [App Engine Standard request routing](/appengine/docs/standard/python/how-requests-are-routed)
     * and [App Engine Flex request routing](/appengine/docs/flexible/python/how-requests-are-routed).
     *
     * Generated from protobuf field <code>string instance = 3;</code>
     * @return string
     */
    public function getInstance()
    {
        return $this->instance;
    }

    /**
     * App instance.
     * By default, the task is sent to an instance which is available when
     * the task is attempted.
     * Requests can only be sent to a specific instance if
     * [manual scaling is used in App Engine Standard](/appengine/docs/python/an-overview-of-app-engine?hl=en_US#scaling_types_and_instance_classes).
     * App Engine Flex does not support instances. For more information, see
     * [App Engine Standard request routing](/appengine/docs/standard/python/how-requests-are-routed)
     * and [App Engine Flex request routing](/appengine/docs/flexible/python/how-requests-are-routed).
     *
     * Generated from protobuf field <code>string instance = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setInstance($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance = $var;

        return $this;
    }

    /**
     * Output only. The host that the task is sent to.
     * For more information, see
     * [How Requests are Routed](/appengine/docs/standard/python/how-requests-are-routed).
     * The host is constructed as:
     * * `host = [application_domain_name]`</br>
     *   `| [service] + '.' + [application_domain_name]`</br>
     *   `| [version] + '.' + [application_domain_name]`</br>
     *   `| [version_dot_service]+ '.' + [application_domain_name]`</br>
     *   `| [instance] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_service] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version_dot_service] + '.' + [application_domain_name]`
     * * `application_domain_name` = The domain name of the app, for
     *   example <app-id>.appspot.com, which is associated with the
     *   queue's project ID. Some tasks which were created using the App Engine
     *   SDK use a custom domain name.
     * * `service =` [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `version =` [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `version_dot_service =`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance =` [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]
     * * `instance_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance_dot_version =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `instance_dot_version_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service] is empty, then the task will be sent
     * to the service which is the default service when the task is attempted.
     * If [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] is empty, then the task will be sent
     * to the version which is the default version when the task is attempted.
     * If [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is empty, then the task
     * will be sent to an instance which is available when the task is
     * attempted.
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], or
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is invalid, then the task
     * will be sent to the default version of the default service when
     * the task is attempted.
     *
     * Generated from protobuf field <code>string host = 4;</code>
     * @return string
     */
    public function getHost()
    {
        return $this->host;
    }

    /**
     * Output only. The host that the task is sent to.
     * For more information, see
     * [How Requests are Routed](/appengine/docs/standard/python/how-requests-are-routed).
     * The host is constructed as:
     * * `host = [application_domain_name]`</br>
     *   `| [service] + '.' + [application_domain_name]`</br>
     *   `| [version] + '.' + [application_domain_name]`</br>
     *   `| [version_dot_service]+ '.' + [application_domain_name]`</br>
     *   `| [instance] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_service] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version] + '.' + [application_domain_name]`</br>
     *   `| [instance_dot_version_dot_service] + '.' + [application_domain_name]`
     * * `application_domain_name` = The domain name of the app, for
     *   example <app-id>.appspot.com, which is associated with the
     *   queue's project ID. Some tasks which were created using the App Engine
     *   SDK use a custom domain name.
     * * `service =` [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `version =` [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `version_dot_service =`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance =` [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance]
     * * `instance_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * * `instance_dot_version =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version]
     * * `instance_dot_version_dot_service =`
     *   [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] `+ '.' +`
     *   [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] `+ '.' +`
     *   [service][google.cloud.tasks.v2beta2.AppEngineRouting.service]
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service] is empty, then the task will be sent
     * to the service which is the default service when the task is attempted.
     * If [version][google.cloud.tasks.v2beta2.AppEngineRouting.version] is empty, then the task will be sent
     * to the version which is the default version when the task is attempted.
     * If [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is empty, then the task
     * will be sent to an instance which is available when the task is
     * attempted.
     * If [service][google.cloud.tasks.v2beta2.AppEngineRouting.service],
     * [version][google.cloud.tasks.v2beta2.AppEngineRouting.version], or
     * [instance][google.cloud.tasks.v2beta2.AppEngineRouting.instance] is invalid, then the task
     * will be sent to the default version of the default service when
     * the task is attempted.
     *
     * Generated from protobuf field <code>string host = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setHost($var)
    {
        GPBUtil::checkString($var, True);
        $this->host = $var;

        return $this;
    }

}

